/**
 *
 * Copyright 2006 The Apache Software Foundation or its licensors, as applicable.
 *
 *  Licensed under the Apache License, Version 2.0 (the "License");
 *  you may not use this file except in compliance with the License.
 *  You may obtain a copy of the License at
 *
 *     http://www.apache.org/licenses/LICENSE-2.0
 *
 *  Unless required by applicable law or agreed to in writing, software
 *  distributed under the License is distributed on an "AS IS" BASIS,
 *  WITHOUT WARRANTIES OR CONDITIONS OF ANY KIND, either express or implied.
 *  See the License for the specific language governing permissions and
 *  limitations under the License.
 */

package org.apache.yoko;

import junit.framework.TestSuite;

public class AbstractCollocTestBase extends AbstractOrbTestBase {
    protected String mainClass;
    protected String[] args;
    public AbstractCollocTestBase(String testName) {
        super(testName);
    }
    public void testColloc() throws Exception {
        client.invokeMain(mainClass, args);
    }
        
    public static TestSuite generateTestSuite(String mainClass, String[][] args) {
        TestSuite suite = new TestSuite();
        for(int i = 0; i < args.length; i++) {
            AbstractCollocTestBase test = new AbstractCollocTestBase("testColloc");
            test.mainClass = mainClass;
            test.args = args[i];
            suite.addTest(test);
        }
        return suite;
    }
}
